/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.core.util;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.MessageFormat;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * データベースユーティリティクラス。
 * @author T.Nishiki
 */
public class InstallerDatabaseUtil {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(InstallerDatabaseUtil.class);
	}


	/**
	 * SQLステートメントをクローズします。
	 * @param statement クローズ対象のステートメント。
	 * @param throwFlag クローズに失敗したときに例外をスローする場合は、true。
	 * @throws InstallerException 上記参照。
	 */
	public static void close(Statement statement, boolean throwFlag)
			throws InstallerException {
		// 運用用コネクションのクローズ
		if (statement != null) {
			try {
				statement.close();
			}
			catch (Exception e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag) {
					throw new InstallerException(e);
				}
			}
		}
	}

	/**
	 * 指定されたクエリーを実行します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param connection クエリ文実行するためのデータベース接続オブジェクト。
	 * @param query 実行するクエリー文字列。
	 * @throws InstallerException データベースアクセス中に例外が発生した場合。
	 */
	public static void executeOneQuery(
			InstallerValues values, Connection connection, String query)
			throws InstallerException {
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"executeOneQuery(InstallerValues," +  query + ")");

		Statement statement = null;
		boolean successFlag = false;
		try {
			// ステートメント取得・実行
			statement = connection.createStatement();
			statement.execute(query);
			// ステートメントクローズ
			InstallerDatabaseUtil.close(statement, true);
			// トランザクション・コミット
			connection.commit();
			// tryブロック末端まで到達
			successFlag = true;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		finally {
			InstallerDatabaseUtil.close(statement, successFlag);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"executeOneQuery(InstallerValues," +  query + ")");
	}

	/**
	 * SQLステートメントと結果セットをクローズします。
	 * @param statement クローズ対象のステートメント。
	 * @param resultSet クローズ対象の結果セット。
	 * @param throwFlag クローズに失敗したときに例外をスローする場合は、true。
	 * @throws InstallerException 上記参照。
	 */
	public static void close(
			Statement statement, ResultSet resultSet, boolean throwFlag)
			throws InstallerException {
		InstallerException thrownException = null;
		// 結果セットのクローズ
		if (resultSet != null) {
			try {
				resultSet.close();
			}
			catch (Exception e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag) {
					thrownException = new InstallerException(e);
				}
			}
		}
		// ステートメントのクローズ
		if (statement != null) {
			try {
				statement.close();
			}
			catch (Exception e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag && thrownException == null) {
					thrownException = new InstallerException(e);
				}
			}
		}
		// 例外が発生した場合はスロー。
		if (thrownException != null) {
			throw thrownException;
		}
	}

	/**
	 * SQL結果セットをクローズします。
	 * @param resultSet クローズ対象のステートメント。
	 * @param throwFlag クローズに失敗したときに例外をスローする場合は、true。
	 * @throws InstallerException 上記参照。
	 */
	public static void close(ResultSet resultSet, boolean throwFlag)
			throws InstallerException {
		// 運用用コネクションのクローズ
		if (resultSet != null) {
			try {
				resultSet.close();
			}
			catch (Exception e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag) {
					throw new InstallerException(e);
				}
			}
		}
	}

	/**
	 * データベース接続オブジェクトを取得します。<br>
	 * @param values インストーラ共通データクラス。
	 * @param dbHost データベース・ホスト名。
	 * @param dbPort データベースポート番号。
	 * @param dbName データベース名。
	 * @param user 接続ユーザ名。
	 * @param pass 接続パスワード。
	 * @param patternKey JDBC文字列取得用のキー名称。
	 * @param autoCommit 作成したコネクションがオートコミットとする場合はtrue。
	 * @return コネクションを取得します。
	 * @throws InstallerException コネクション取得に失敗した場合
	 */
	public static Connection getConnection(
			InstallerValues values,
			String dbHost, String dbPort, String dbName,
			String user, String pass, String patternKey, boolean autoCommit)
			throws InstallerException {

		LoggerUtil.methodHead(_logger,
			"getConnection(InstallerValues,"
				+ dbHost + "," + dbPort + "," + dbName
				+ "," + user + "," + pass
				+ "," + patternKey + "," + autoCommit + ")");

		// このメソッドの戻り値
		Connection connection = null;

		try {
			// JDBCドライバクラスを取得
			String driverClassName = values.getDbProperty("jdbcDriver");
			Class.forName(driverClassName);
			////////////////////////////////////////////////////////////////////
			// コネクション取得
			// =================================================================
			// コネクション文字列のパターンを取得
			String connectionString	= values.getDbProperty(patternKey);
			// コネクション文字列のパラメータを取得
			Object[] connectionParams = new Object[] {
				// データベースホスト
				dbHost,
				// ポート番号
				dbPort,
				// データベース名
				dbName,
			};
			// コネクション文字列生成
			connectionString = MessageFormat.format(
				connectionString, connectionParams);
			_logger.info("connectionString=[" + connectionString + "]");
			// コネクション生成
			connection = DriverManager.getConnection(
					connectionString, user, pass);
			connection.setAutoCommit(autoCommit);
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		LoggerUtil.methodTail(_logger,
			"getConnection(InstallerValues,"
				+ dbHost + "," + dbPort + "," + dbName
				+ "," + user + "," + pass
				+ "," + patternKey + "," + autoCommit + ")");
		return connection;
	}
}
